/******************************************************************
*******************************************************************
***																***
***		BonFriioView application implementation 				***
***																***
*******************************************************************
******************************************************************/

#include <windows.h>
#include "lernel32.h"

/******************************************************************
***																***
***		Local constants/macros definition   					***
***																***
******************************************************************/

#define PART_OF_TARGET_DEVICE_NAME "\\\\?\\USB#VID_"

/******************************************************************
***																***
***		Name:	Setup for application   						***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL SetupApp( void )
{
	return TRUE ;
}

/******************************************************************
***																***
***		Name:	Cleanup for application 						***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

void CleanupApp( void )
{
}

/******************************************************************
***																***
***		Name:	Answer if the device is target  				***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL IsTargetDevice( LPCSTR lpFileName )
{
	if ( strstr( lpFileName, PART_OF_TARGET_DEVICE_NAME ) ) {
		DebugPrintF( "Open : %s\n", lpFileName ) ;
		return TRUE ;
	}
	else return FALSE ;
}

/******************************************************************
***																***
***		Name:	Target is opened								***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

void TargetOpened( HANDLE hDevice )
{
	DebugPrintF( "Target device is opened\n" ) ;
}

/******************************************************************
***																***
***		Name:	Target is closed								***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

void TargetClosed( void )
{
	DebugPrintF( "Target device is closed\n" ) ;
}

/******************************************************************
***																***
***		Name:	Override DeviceIoControl						***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL OrDeviceIoControl( BOOL& bRet,
	HANDLE& hDevice, DWORD& dwIoControlCode,
	LPVOID& lpInBuffer, DWORD& nInBufferSize,
	LPVOID& lpOutBuffer, DWORD& nOutBufferSize, LPDWORD& lpBytesReturned,
	LPOVERLAPPED& lpOverlapped )
{
	DebugPrintF( "DIO %08X/%p\n", dwIoControlCode, lpOverlapped ) ;
	return FALSE ;
}

/******************************************************************
***																***
***		Name:	Override CancelIo   							***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL OrCancelIo( BOOL& bRet,
	HANDLE& hFile )
{
	DebugPrintF( "CancelIo() is called.\n" ) ;
	return FALSE ;
}

/******************************************************************
***																***
***		Name:	Override GetOverlappedResult					***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL OrGetOverlappedResult( BOOL& bRet,
	HANDLE& hFile, LPOVERLAPPED& lpOverlapped,
	LPDWORD& lpNumberOfBytesTransferred, BOOL& bWait )
{
	DebugPrintF( "GetOverlappedResult( %p )\n", lpOverlapped ) ;
	return FALSE ;
}
