/******************************************************************
*******************************************************************
***																***
***		Hooked APIs entity                              		***
***																***
*******************************************************************
******************************************************************/

#include <windows.h>
#include "lernel32.h"

/******************************************************************
***																***
***		Local static variables  								***
***																***
******************************************************************/

HANDLE hTarget ;

/******************************************************************
***																***
***		Name:	Setup for Hooked APIs   						***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL SetupHook( void )
{
								/*************************************/
								/**	initialize variables			**/
								/*************************************/
	hTarget = NULL ;
	return TRUE ;
}

/******************************************************************
***																***
***		Name:	Cleanup for Hooked APIs 						***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

void CleanupHook( void )
{
								/*************************************/
								/**	check if target is closed   	**/
								/*************************************/
	if ( hTarget ) {
		DebugPrintF( "ERROR : DLL is unloaded without close target device\n" ) ;
		//CloseHandle( hTarget ) ;
		hTarget = NULL ;
	}
}

/******************************************************************
***																***
***		Name:	CreateFileA hooked function						***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

HANDLE WINAPI d_CreateFileA(
	LPCSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode,
	LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition,
	DWORD dwFlagsAndAttributes, HANDLE hTemplateFile )
{
								/*************************************/
								/**	convert to upper case			**/
								/*************************************/
	char szTmp[_MAX_PATH*2] ;
	strcpy_s( szTmp, sizeof(szTmp), lpFileName ) ;
	_strupr_s( szTmp, sizeof(szTmp) ) ;
								/*************************************/
								/**	ask if the device is target 	**/
								/**	(only one device can be hooked) **/
								/*************************************/
	BOOL bTarget = ( hTarget == NULL ) && IsTargetDevice( szTmp ) ;
								/*************************************/
								/**	open file/device				**/
								/*************************************/
	#ifdef OPEN_NUL_INSTEAD
	if ( bTarget ) lpFileName = "nul" ;
	#endif
	HANDLE hRet = p_CreateFileA( lpFileName, dwDesiredAccess, dwShareMode,
		lpSecurityAttributes, dwCreationDisposition,
		dwFlagsAndAttributes, hTemplateFile ) ;
	if ( hRet == INVALID_HANDLE_VALUE ) return hRet ;
								/*************************************/
								/**	notify to application   		**/
								/*************************************/
	if ( bTarget ) {
		hTarget = hRet ;
		TargetOpened( hTarget ) ;
	}
	return hRet ;
}

/******************************************************************
***																***
***		Name:	CreateFileW hooked function 					***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

HANDLE WINAPI d_CreateFileW(
	LPCWSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode,
	LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition,
	DWORD dwFlagsAndAttributes, HANDLE hTemplateFile )
{
								/*************************************/
								/**	convert UNICODE -> upper MBCS	**/
								/*************************************/
	char szTmp[_MAX_PATH*2] ;
	memset( szTmp, 0, sizeof(szTmp) ) ;
	int cchWideChar = (int)wcslen( lpFileName ) ;
	WideCharToMultiByte( CP_ACP, 0, lpFileName, cchWideChar,
		szTmp, sizeof(szTmp), NULL, NULL ) ;
	_strupr_s( szTmp, sizeof(szTmp) ) ;
								/*************************************/
								/**	ask if the device is target 	**/
								/**	(only one device can be hooked) **/
								/*************************************/
	BOOL bTarget = ( hTarget == NULL ) && IsTargetDevice( szTmp ) ;
								/*************************************/
								/**	open file/device				**/
								/*************************************/
	#ifdef OPEN_NUL_INSTEAD
	if ( bTarget ) lpFileName = L"nul" ;
	#endif
	HANDLE hRet = p_CreateFileW( lpFileName, dwDesiredAccess, dwShareMode,
		lpSecurityAttributes, dwCreationDisposition,
		dwFlagsAndAttributes, hTemplateFile ) ;
	if ( hRet == INVALID_HANDLE_VALUE ) return hRet ;
								/*************************************/
								/**	notify to application   		**/
								/*************************************/
	if ( bTarget ) {
		hTarget = hRet ;
		TargetOpened( hTarget ) ;
	}
	return hRet ;
}

/******************************************************************
***																***
***		Name:	CloseHandle hooked function 					***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL WINAPI d_CloseHandle(
	HANDLE hObject )
{
	if ( hTarget && hObject == hTarget ) {
		TargetClosed() ;
		hTarget = NULL ;
	}
	return p_CloseHandle( hObject ) ;
}

/******************************************************************
***																***
***		Name:	DeviceIoControl hookked function				***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL WINAPI d_DeviceIoControl(
	HANDLE hDevice, DWORD dwIoControlCode,
	LPVOID lpInBuffer, DWORD nInBufferSize,
	LPVOID lpOutBuffer, DWORD nOutBufferSize, LPDWORD lpBytesReturned,
	LPOVERLAPPED lpOverlapped )
{
								/*************************************/
								/**	call override function  		**/
								/*************************************/
	if ( hTarget && hDevice == hTarget ) {
		BOOL bRet ;
		if ( OrDeviceIoControl( bRet,
			hDevice, dwIoControlCode,
			lpInBuffer, nInBufferSize,
			lpOutBuffer, nOutBufferSize, lpBytesReturned,
			lpOverlapped ) ) return bRet ;
	}
								/*************************************/
								/**	call original API   			**/
								/*************************************/
	return p_DeviceIoControl( hDevice, dwIoControlCode,
		lpInBuffer, nInBufferSize,
		lpOutBuffer, nOutBufferSize, lpBytesReturned,
		lpOverlapped ) ;
}

/******************************************************************
***																***
***		Name:	CancelIo hooked function						***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL WINAPI d_CancelIo(
	HANDLE hFile )
{
								/*************************************/
								/**	call override function  		**/
								/*************************************/
	if ( hTarget && hFile == hTarget ) {
		BOOL bRet ;
		if ( OrCancelIo( bRet, hFile ) ) return bRet ;
	}
								/*************************************/
								/**	call original API   			**/
								/*************************************/
	return p_CancelIo( hFile ) ;
}

/******************************************************************
***																***
***		Name:	GetOverlappedResult hooked function 			***
***																***
*************************<< Function >>****************************
***																***
***																***
***																***
******************************************************************/

BOOL WINAPI d_GetOverlappedResult(
	HANDLE hFile, LPOVERLAPPED lpOverlapped,
	LPDWORD lpNumberOfBytesTransferred, BOOL bWait )
{
								/*************************************/
								/**	call override function  		**/
								/*************************************/
	if ( hTarget && hFile == hTarget ) {
		BOOL bRet ;
		if ( OrGetOverlappedResult( bRet,
			hFile, lpOverlapped,
			lpNumberOfBytesTransferred, bWait ) ) return bRet ;
	}
								/*************************************/
								/**	call original API   			**/
								/*************************************/
	return p_GetOverlappedResult( hFile, lpOverlapped,
		lpNumberOfBytesTransferred, bWait ) ;
}

